com.verisign.epp.codec.mark

## Class EPPTrademark

- java.lang.Object
- - com.verisign.epp.codec.mark.EPPTrademark

- All Implemented Interfaces:
    EPPCodecComponent, java.io.Serializable, java.lang.Cloneable

      public class EPPTrademark
      extends java.lang.Object
      implements EPPCodecComponent

  Class for a Trademark that can be included in the list of trademarks contained in the `EPPMark`.
  See Also:
    `EPPMark`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ELM_LOCALNAME` Constant for the trademark local name
    `static java.lang.String` | `ELM_NAME` Constant for the trademark tag

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EPPTrademark()` Create an `EPPTrademark` instance.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClass(java.lang.String aClass)` Adds a Nice Classification class number to the list of classes.
    `void` | `addContact(EPPMarkContact aContact)` Adds a contact to the list of contacts of the trademark.
    `void` | `addHolder(EPPMarkContact aHolder)` Adds a holder to the list of holders of the trademark.
    `void` | `addLabel(java.lang.String aLabel)` Adds a domain name label to the domain name labels that corresponds to the trademark.
    `java.lang.Object` | `clone()` Clone `EPPTrademark`.
    `void` | `decode(byte[] aMarkArray)` Decode the `EPPTrademark` attributes from the input `byte[]`.
    `void` | `decode(org.w3c.dom.Element aElement)` Decode the `EPPTrademark` component
    `byte[]` | `encode()` Encode the trademark to a `byte[]`.
    `org.w3c.dom.Element` | `encode(org.w3c.dom.Document aDocument)` Sets all this instance's data in the given XML document
    `boolean` | `equals(java.lang.Object aObject)` implements a deep `EPPTrademark` compare.
    `java.util.Date` | `getApDate()` Gets the date the trademark was applied for.
    `java.lang.String` | `getApId()` Gets the application ID registered in the trademark office.
    `java.util.List<java.lang.String>` | `getClasses()` Gets list of Nice Classification class numbers.
    `java.util.List<EPPMarkContact>` | `getContacts()` Gets contacts of the trademark.
    `java.util.Date` | `getExDate()` Gets the date of expiration of the trademark.
    `java.lang.String` | `getGoodsAndServices()` Gets full description of the goods and services mentioned in the trademark registration document.
    `java.util.List<EPPMarkContact>` | `getHolders()` Gets holders of the trademark.
    `java.lang.String` | `getId()` Gets the identifier for the trademark.
    `java.lang.String` | `getJurisdiction()` Gets the two-character code of the jurisdiction where the trademark was registered.
    `java.util.List<java.lang.String>` | `getLabels()` Gets the domain name labels that corresponds to the trademark.
    `java.lang.String` | `getName()` Gets the registered trademark text string.
    `java.lang.String` | `getNamespace()` Returns the XML namespace associated with the `EPPCodecComponent`.
    `java.util.Date` | `getRegDate()` Gets the date the trademark was registered.
    `java.lang.String` | `getRegNum()` Gets the trademark registration ID (number) registered in the trademark office.
    `void` | `setApDate(java.util.Date aApDate)` Sets the date the trademark was applied for.
    `void` | `setApId(java.lang.String aApId)` Sets the application ID registered in the trademark office.
    `void` | `setClasses(java.util.List<java.lang.String> aClasses)` Sets list of Nice Classification class numbers.
    `void` | `setContacts(java.util.List<EPPMarkContact> aContacts)` Sets contacts of the trademark.
    `void` | `setExDate(java.util.Date aExDate)` Sets the date of expiration of the trademark.
    `void` | `setGoodsAndServices(java.lang.String aGoodsAndServices)` Sets full description of the goods and services mentioned in the trademark registration document.
    `void` | `setHolders(java.util.List<EPPMarkContact> aHolders)` Sets holders of the trademark.
    `void` | `setId(java.lang.String aId)` Sets the identifier for the trademark.
    `void` | `setJurisdiction(java.lang.String aJurisdiction)` Sets the two-character code of the jurisdiction where the trademark was registered.
    `void` | `setLabels(java.util.List<java.lang.String> aLabels)` Sets the domain name labels that corresponds to the trademark.
    `void` | `setName(java.lang.String aName)` Sets the registered trademark text string.
    `void` | `setRegDate(java.util.Date aRegDate)` Sets the date the trademark was registered.
    `void` | `setRegNum(java.lang.String aRegNum)` Sets the trademark registration ID (number) registered in the trademark office.
    `java.lang.String` | `toString()` Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ELM_LOCALNAME

          public static final java.lang.String ELM_LOCALNAME

      Constant for the trademark local name
      See Also:
        Constant Field Values

    - #### ELM_NAME

          public static final java.lang.String ELM_NAME

      Constant for the trademark tag
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EPPTrademark

          public EPPTrademark()

      Create an `EPPTrademark` instance. Use the setter methods to set the attributes of the instance.

  - ### Method Detail

    - #### clone

          public java.lang.Object clone()
                                 throws java.lang.CloneNotSupportedException

      Clone `EPPTrademark`.
      Specified by:
        `clone` in interface `EPPCodecComponent`
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        clone of `EPPTrademark`
      Throws:
        `java.lang.CloneNotSupportedException` - standard Object.clone exception

    - #### encode

          public byte[] encode()
                        throws EPPEncodeException

      Encode the trademark to a `byte[]`.
      Returns:
        Encoded trademark
      Throws:
        `EPPEncodeException` - Error encoding the trademark

    - #### encode

          public org.w3c.dom.Element encode(org.w3c.dom.Document aDocument)
                                     throws EPPEncodeException

      Sets all this instance's data in the given XML document
      Specified by:
        `encode` in interface `EPPCodecComponent`
      Parameters:
        `aDocument` - a DOM Document to attach data to.
      Returns:
        The root element of this component.
      Throws:
        `EPPEncodeException` - Thrown if any errors prevent encoding.

    - #### decode

          public void decode(byte[] aMarkArray)
                      throws EPPDecodeException

      Decode the `EPPTrademark` attributes from the input `byte[]`.
      Parameters:
        `aMarkArray` - `byte[]` to decode the attribute values
      Throws:
        `EPPDecodeException` - Error decoding the `byte[]`.

    - #### decode

          public void decode(org.w3c.dom.Element aElement)
                      throws EPPDecodeException

      Decode the `EPPTrademark` component
      Specified by:
        `decode` in interface `EPPCodecComponent`
      Parameters:
        `aElement` - Root element of the `EPPTrademark`
      Throws:
        `EPPDecodeException` - Error decoding the `EPPTrademark`

    - #### equals

          public boolean equals(java.lang.Object aObject)

      implements a deep `EPPTrademark` compare.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `aObject` - `EPPTrademark` instance to compare with
      Returns:
        true if equal false otherwise

    - #### getId

          public java.lang.String getId()

      Gets the identifier for the trademark.
      Returns:
        The identifier for the trademark if set; `null` otherwise.

    - #### setId

          public void setId(java.lang.String aId)

      Sets the identifier for the trademark.
      Parameters:
        `aId` - Identifier for the trademark

    - #### getName

          public java.lang.String getName()

      Gets the registered trademark text string.
      Returns:
        The registered trademark text string if set; `null` otherwise.

    - #### setName

          public void setName(java.lang.String aName)

      Sets the registered trademark text string.
      Parameters:
        `aName` - the registered trademark text string

    - #### getHolders

          public java.util.List<EPPMarkContact> getHolders()

      Gets holders of the trademark.
      Returns:
        the holders of the trademark if set; Empty `List` otherwise.

    - #### setHolders

          public void setHolders(java.util.List<EPPMarkContact> aHolders)

      Sets holders of the trademark.
      Parameters:
        `aHolders` - the holders of the trademark

    - #### addHolder

          public void addHolder(EPPMarkContact aHolder)

      Adds a holder to the list of holders of the trademark.
      Parameters:
        `aHolder` - Holder to add to list of holders of the trademark.

    - #### getContacts

          public java.util.List<EPPMarkContact> getContacts()

      Gets contacts of the trademark.
      Returns:
        the contacts of the trademark if set; Empty `List` otherwise.

    - #### setContacts

          public void setContacts(java.util.List<EPPMarkContact> aContacts)

      Sets contacts of the trademark.
      Parameters:
        `aContacts` - the contacts of the trademark

    - #### addContact

          public void addContact(EPPMarkContact aContact)

      Adds a contact to the list of contacts of the trademark.
      Parameters:
        `aContact` - Contact to add to list of contacts of the trademark.

    - #### getJurisdiction

          public java.lang.String getJurisdiction()

      Gets the two-character code of the jurisdiction where the trademark was registered. This is a two-character code from [WIPO.ST3].
      Returns:
        Jurisdiction if set; `null` otherwise.

    - #### setJurisdiction

          public void setJurisdiction(java.lang.String aJurisdiction)

      Sets the two-character code of the jurisdiction where the trademark was registered. This is a two-character code from [WIPO.ST3].
      Parameters:
        `aJurisdiction` - Jurisdiction where trademark was registered.

    - #### getClasses

          public java.util.List<java.lang.String> getClasses()

      Gets list of Nice Classification class numbers.
      Returns:
        list of Nice Classification class numbers if defined; empty list otherwise.

    - #### setClasses

          public void setClasses(java.util.List<java.lang.String> aClasses)

      Sets list of Nice Classification class numbers.
      Parameters:
        `aClasses` - list of Nice Classification class numbers

    - #### addClass

          public void addClass(java.lang.String aClass)

      Adds a Nice Classification class number to the list of classes.
      Parameters:
        `aClass` - Nice Classification class number to add

    - #### getLabels

          public java.util.List<java.lang.String> getLabels()

      Gets the domain name labels that corresponds to the trademark.
      Returns:
        the domain name labels that corresponds to the trademark if set; Empty `List` otherwise.

    - #### setLabels

          public void setLabels(java.util.List<java.lang.String> aLabels)

      Sets the domain name labels that corresponds to the trademark.
      Parameters:
        `aLabels` - the domain name labels that corresponds to the trademark

    - #### addLabel

          public void addLabel(java.lang.String aLabel)

      Adds a domain name label to the domain name labels that corresponds to the trademark.
      Parameters:
        `aLabel` - Domain name label to add.

    - #### getGoodsAndServices

          public java.lang.String getGoodsAndServices()

      Gets full description of the goods and services mentioned in the trademark registration document.
      Returns:
        The goods and services if set; `null` otherwise.

    - #### setGoodsAndServices

          public void setGoodsAndServices(java.lang.String aGoodsAndServices)

      Sets full description of the goods and services mentioned in the trademark registration document.
      Parameters:
        `aGoodsAndServices` - The goods and services

    - #### getApId

          public java.lang.String getApId()

      Gets the application ID registered in the trademark office.
      Returns:
        Application ID registered in the trademark office if defined; `null` otherwise.

    - #### setApId

          public void setApId(java.lang.String aApId)

      Sets the application ID registered in the trademark office.
      Parameters:
        `aApId` - Application ID registered in the trademark office.

    - #### getApDate

          public java.util.Date getApDate()

      Gets the date the trademark was applied for.
      Returns:
        The date the trademark was applied for if defined; `null` otherwise.

    - #### setApDate

          public void setApDate(java.util.Date aApDate)

      Sets the date the trademark was applied for.
      Parameters:
        `aApDate` - The date the trademark was applied for.

    - #### getRegNum

          public java.lang.String getRegNum()

      Gets the trademark registration ID (number) registered in the trademark office.
      Returns:
        The trademark registration ID (number) registered in the trademark office.

    - #### setRegNum

          public void setRegNum(java.lang.String aRegNum)

      Sets the trademark registration ID (number) registered in the trademark office.
      Parameters:
        `aRegNum` - The trademark registration ID (number) registered in the trademark office.

    - #### getRegDate

          public java.util.Date getRegDate()

      Gets the date the trademark was registered.
      Returns:
        The date the trademark was registered if set; `null` otherwise.

    - #### setRegDate

          public void setRegDate(java.util.Date aRegDate)

      Sets the date the trademark was registered.
      Parameters:
        `aRegDate` - The date the trademark was registered

    - #### getExDate

          public java.util.Date getExDate()

      Gets the date of expiration of the trademark.
      Returns:
        the date of expiration of the trademark if set; `null` otherwise.

    - #### setExDate

          public void setExDate(java.util.Date aExDate)

      Sets the date of expiration of the trademark.
      Parameters:
        `aExDate` - The date of expiration of the trademark

    - #### toString

          public java.lang.String toString()

      Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        Indented XML `String` if successful; `ERROR` otherwise.

    - #### getNamespace

          public java.lang.String getNamespace()

      Returns the XML namespace associated with the `EPPCodecComponent`.
      Specified by:
        `getNamespace` in interface `EPPCodecComponent`
      Returns:
        XML namespace for the `EPPCodecComponent`.